<?php
namespace TekNutri\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\DBAL\Connection;
use Exception;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class CadastroDePara {
 
	protected $connection;
	protected $environment;
	protected $crudService;

    public function __construct($crudService, $connection, $environment){
        $this->crudService   = $crudService;
        $this->connection    = $connection;
        $this->environment   = $environment;
	}
	
	public function changedFind(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName('cadastroDePara');
            $this->crudService->find($response, $filterCriteria);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function procedureAssociacaoAutomatica ($request, $response){
         try {
            $row = $request->getRow();
            
            $procedure = new StoredProcedure($this->connection, 'SIT_ASSOC_AUTO');
            
            $procedure->addParam(new Param('P_NRORGINT', Param::PARAM_INPUT, $row['NRORGINT'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_OPERADOR', Param::PARAM_INPUT, $this->environment->getCdOperador(), Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_RETORNO',  Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 10));
    
            $retorno = $procedure->execute();
            $response->addDataSet(new DataSet("retorno", $retorno));
            
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        } 
    }
  
}